Loading...
Searching...
No Matches
BALL::ShiftModel Class Reference
Molecular Modeling » Nuclear Magnetic Resonance Spectroscopy » Shift model classes

`#include <BALL/NMR/shiftModel.h>`

Inheritance diagram for BALL::ShiftModel:

## Public Types

Type definitions
typedef std::list< ShiftModule * > | ModuleList
typedef void *(* | CreateMethod) ()
typedef StringHashMap< CreateMethod > | CreateMethodMap
Public Types inherited from BALL::UnaryFunctor< ArgumentType, ResultType >
typedef ResultType | result_type
typedef ArgumentType | argument_type
typedef ArgumentType & | argument_reference
typedef const ArgumentType & | const_argument_reference
typedef ArgumentType * | argument_pointer
typedef const ArgumentType * | const_argument_pointer

## Public Member Functions

Constructors and Destructors
| ShiftModel ()
| ShiftModel (const String &filename)
| ShiftModel (const ShiftModel &model)
virtual | ~ShiftModel ()
void | clear ()
Accessors
Parameters & | getParameters ()
ModuleList & | getModuleList ()
void | setFilename (const String &filename)
const String & | getFilename () const
void | registerModule (const String &name, CreateMethod method)
void | unregisterModule (const String &name)
Predicates
bool | isValid () const
bool | isRegistered (const String &name) const
Assignment
const ShiftModel & | operator= (const ShiftModel &model)
const ShiftModel & | operator= (const String &filename)
Public Member Functions inherited from BALL::ShiftModule
| ShiftModule ()
| ShiftModule (Parameters &parameters, const String &name="")
| ShiftModule (const ShiftModule &module)
virtual | ~ShiftModule ()
const ShiftModule & | operator= (const ShiftModule &module)
void | setName (const String &name)
const String & | getName () const
void | setParameters (Parameters &parameters)
const Parameters * | getParameters () const
virtual void | init ()
bool | isValid () const
Public Member Functions inherited from BALL::UnaryProcessor< Composite >
| UnaryProcessor ()
| UnaryProcessor (const UnaryProcessor &)
virtual | ~UnaryProcessor ()

## Public Attributes

Public Attributes
Options | options

## Static Public Attributes

Constants
static const char * | MODULE_LIST_SECTION
Static Public Attributes inherited from BALL::ShiftModule
static const char * | PROPERTY__SHIFT
static const char * | PROPERTY__EXPERIMENTAL__SHIFT

## Processor related methods

Parameters | parameters_
ModuleList | modules_
CreateMethodMap | registered_modules_
bool | valid_
bool | start ()
bool | finish ()
Processor::Result | operator() (Composite &composite)
bool | init_ ()
ShiftModule * | createModule_ (const String &type, const String &name) const
void | registerStandardModules_ ()

## Additional Inherited Members

String | module_name_
Parameters * | parameters_
bool | valid_

## Detailed Description

A class representing a complete parameterized NMR shift model. The model consists of a set of single contributions (e.g. ring curent, magnetic anisotropy, etc.). Each of these contributions is calculated by a separate ShiftModule object. ShiftModel contains a list of these processors and is also derived from ShiftModul. Hence, it can be applied to arbitrary kernel objects in the same fashion as ShiftModule s.

Definition at line 32 of file shiftModel.h.

## Member Typedef Documentation

## CreateMethod

typedef void *(* BALL::ShiftModel::CreateMethod) ()

The creation method type. This type describes a method that can construct an object of type ShiftModule.

Definition at line 51 of file shiftModel.h.

## CreateMethodMap

typedef StringHashMap<CreateMethod> BALL::ShiftModel::CreateMethodMap

The creation method hash map type. This type is used internally to store the creation method corresponding to a certain symbolic name (usually the class name).

Definition at line 57 of file shiftModel.h.

## ModuleList

typedef std::list<ShiftModule*> BALL::ShiftModel::ModuleList

The module list type

Definition at line 45 of file shiftModel.h.

## Constructor & Destructor Documentation

## ShiftModel() [1/3]

BALL::ShiftModel::ShiftModel | ( |  | ) |

Default Constructor

## ShiftModel() [2/3]

BALL::ShiftModel::ShiftModel | ( | const String & | filename | ) |

Detailed Constructor

## ShiftModel() [3/3]

BALL::ShiftModel::ShiftModel | ( | const ShiftModel & | model | ) |

Copy constructor

## ~ShiftModel()

virtual BALL::ShiftModel::~ShiftModel | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## clear()

void BALL::ShiftModel::clear | ( |  | ) |

virtual

Clear method. This method destructs all shift modules in the module list. Then, it clears the module list, the parameters, and the options.

Reimplemented from BALL::ShiftModule.

## createModule_()

ShiftModule * BALL::ShiftModel::createModule_ | ( | const String & | type,
|  | const String & | name ) const

protected

## finish()

bool BALL::ShiftModel::finish | ( |  | ) |

virtual

Finish method

Reimplemented from BALL::ShiftModule.

## getFilename()

const String & BALL::ShiftModel::getFilename | ( |  | ) | const

Return the parameter filename.

## getModuleList()

ModuleList & BALL::ShiftModel::getModuleList | ( |  | ) |

Return the list of modules

## getParameters()

Parameters & BALL::ShiftModel::getParameters | ( |  | ) |

## init_()

bool BALL::ShiftModel::init_ | ( |  | ) |

protected

## isRegistered()

bool BALL::ShiftModel::isRegistered | ( | const String & | name | ) | const

Check whether a module of this name is registered

## isValid()

bool BALL::ShiftModel::isValid | ( |  | ) | const

Validity flag

## operator()()

Processor::Result BALL::ShiftModel::operator() | ( | Composite & | composite | ) |

virtual

Application method

Reimplemented from BALL::UnaryProcessor< Composite >.

## operator=() [1/2]

const ShiftModel & BALL::ShiftModel::operator= | ( | const ShiftModel & | model | ) |

Assignment operator

## operator=() [2/2]

const ShiftModel & BALL::ShiftModel::operator= | ( | const String & | filename | ) |

Assignment operator (via filename).

## registerModule()

void BALL::ShiftModel::registerModule | ( | const String & | name,
|  | CreateMethod | method )

Register a new module type.

Exceptions

  BALL::Exception::NullPointer |

## registerStandardModules_()

void BALL::ShiftModel::registerStandardModules_ | ( |  | ) |

protected

## setFilename()

void BALL::ShiftModel::setFilename | ( | const String & | filename | ) |

Set the parameter filename.

Exceptions

  BALL::Exception::FileNotFound |

## start()

bool BALL::ShiftModel::start | ( |  | ) |

virtual

Start method

Reimplemented from BALL::ShiftModule.

## unregisterModule()

void BALL::ShiftModel::unregisterModule | ( | const String & | name | ) |

Unregister a module type.

## Member Data Documentation

## MODULE_LIST_SECTION

const char* BALL::ShiftModel::MODULE_LIST_SECTION

static

The name of the section containing the module types and names of the model

Definition at line 66 of file shiftModel.h.

## modules_

ModuleList BALL::ShiftModel::modules_

protected

Definition at line 205 of file shiftModel.h.

## options

Options BALL::ShiftModel::options

Options

Definition at line 159 of file shiftModel.h.

## parameters_

Parameters BALL::ShiftModel::parameters_

protected

Definition at line 201 of file shiftModel.h.

## registered_modules_

CreateMethodMap BALL::ShiftModel::registered_modules_

protected

Definition at line 209 of file shiftModel.h.

## valid_

bool BALL::ShiftModel::valid_

protected

Definition at line 214 of file shiftModel.h.